<template>
  <label class="checkbox-wrapper">
    <input v-model="proxyChecked" type="checkbox" :value="value" />
    <span class="checkmark"></span>
    {{ label }}
    <span>({{ count }})</span>
  </label>
</template>

<script>
export default {
  name: 'Checkbox',
  model: {
    prop: 'checked',
    event: 'change',
  },
  props: {
    label: {
      type: String,
      default: '',
    },
    count: {
      type: Number,
      default: null,
    },
    checked: {
      type: [Array, Boolean],
      default: false,
    },
    value: {
      type: [String, Number, Boolean],
      default: null,
    },
  },
  computed: {
    proxyChecked: {
      get() {
        return this.checked
      },
      set(val) {
        this.$emit('change', val)
      },
    },
  },
}
</script>

<style scoped>
.checkbox-wrapper {
  display: block;
  position: relative;
  padding-right: 30px;
  margin-bottom: 16px;
  cursor: pointer;
  -webkit-user-select: none;
  -moz-user-select: none;
  -ms-user-select: none;
  user-select: none;
}

/* Hide the browser's default checkbox */
.checkbox-wrapper input {
  position: absolute;
  opacity: 0;
  cursor: pointer;
  height: 0;
  width: 0;
}

/* Create a custom checkbox */
.checkmark {
  position: absolute;
  top: 50%;
  transform: translateY(-50%);
  right: 0;
  height: 20px;
  width: 20px;
  border: 2px solid #9d9d9d;
  border-radius: 0.25rem;
  transition: 0.2s;
}

/* On mouse-over, add a grey background color */
.checkbox-wrapper:hover input ~ .checkmark {
  background-color: #9fe7da;
  border-color: #00c09d;
  transition: all 0.2s;
}

/* When the checkbox is checked, add a blue background */
.checkbox-wrapper input:checked ~ .checkmark {
  background-color: #00c09d;
  border-color: #00c09d;
}

/* Create the checkmark/indicator (hidden when not checked) */
.checkmark:after {
  content: '';
  position: absolute;
  display: none;
}

/* Show the checkmark when checked */
.checkbox-wrapper input:checked ~ .checkmark:after {
  display: block;
}

/* Style the checkmark/indicator */
.checkbox-wrapper .checkmark:after {
  left: 5px;
  top: 0px;
  width: 6px;
  height: 14px;
  border: solid white;
  border-width: 0 2px 2px 0px;
  -webkit-transform: rotate(45deg);
  -ms-transform: rotate(45deg);
  transform: rotate(45deg);
}
</style>